Attribute VB_Name = "mAnimation"
Private Declare Function CreateWindowEx Lib "User32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "User32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowRect Lib "User32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function MoveWindow Lib "User32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

' Window Styles
Private Const WS_CHILD = &H40000000
Private Const WS_VISIBLE = &H10000000
Private Type tagInitCommonControlsEx
        dwSize As Long
        dwICC As Long
End Type
Private Declare Sub InitCommonControls Lib "Comctl32.dll" ()
Private Declare Function InitCommonControlsEx Lib "Comctl32.dll" (iccex As tagInitCommonControlsEx) As Boolean
Private Const WM_USER = &H400
Private Const ICC_ANIMATE_CLASS = &H80
Private Const ANIMATE_CLASSA = "SysAnimate32"

Private Const ACS_CENTER = &H1
Private Const ACS_TRANSPARENT = &H2
Private Const ACS_AUTOPLAY = &H4
Private Const ACS_TIMER = &H8

Private Const ACM_OPEN = (WM_USER + 100)
Private Const ACM_PLAY = (WM_USER + 101)
Private Const ACM_STOP = (WM_USER + 102)
Dim bInit As Boolean
Dim hAVI As Long
Dim hModule As Long

Public Function PlayAvi(ByVal hParent As Long, ByVal sFileName As String, Optional ResourceID As Long = 0, Optional bCenter As Boolean = True)
  Dim lStyle As Long, ret As Long
  On Error GoTo ErrPlay
  If Not bInit Then Call InitComctl32(ICC_ANIMATE_CLASS)
  lStyle = WS_CHILD Or WS_VISIBLE Or ACS_AUTOPLAY Or ACS_TRANSPARENT
  If hAVI Then DestroyWindow (hAVI)
  If ResourceID = 0 Then
     hAVI = CreateWindowEx(0, ANIMATE_CLASSA, vbNullString, lStyle, 0, 0, 0, 0, hParent, 0&, App.hInstance, ByVal 0&)
     ret = SendMessage(hAVI, ACM_OPEN, 0, ByVal sFileName)
  Else
     hModule = LoadLibrary(sFileName)
     If hModule = 0 Then GoTo ErrPlay
     hAVI = CreateWindowEx(0, ANIMATE_CLASSA, vbNullString, lStyle, 0, 0, 0, 0, hParent, 0&, hModule, ByVal 0&)
     ret = SendMessage(hAVI, ACM_OPEN, 0, ByVal ResourceID)
  End If
  If ret = 0 Or hAVI = 0 Then GoTo ErrPlay
  If bCenter Then Call CenterAVI(hParent)
  Call SendMessage(hAVI, ACM_PLAY, -1, ByVal 0&)
  Exit Function
ErrPlay:
  If hModule Then Call FreeLibrary(hModule)
  Call DestroyWindow(hAVI)
End Function

Public Sub StopAvi()
  If hAVI Then
     Call SendMessage(hAVI, ACM_STOP, 0, ByVal 0&)
     Call SendMessage(hAVI, ACM_OPEN, 0, ByVal 0&)
     Call DestroyWindow(hAVI)
  End If
  If hModule Then Call FreeLibrary(hModule)
End Sub
Private Sub InitComctl32(dwFlags As Long)
   Dim icc As tagInitCommonControlsEx
   bInit = True
   On Error GoTo Err_OldVersion
   icc.dwSize = Len(icc)
   icc.dwICC = dwFlags
   InitCommonControlsEx icc
   On Error GoTo 0
   Exit Sub
Err_OldVersion:
   InitCommonControls
End Sub

Private Sub CenterAVI(ByVal h As Long)
  Dim rcAVI As RECT, rcParent As RECT
  Call GetWindowRect(h, rcParent)
  Call GetWindowRect(hAVI, rcAVI)
  Call MoveWindow(hAVI, (rcParent.Right - rcParent.Left - rcAVI.Right + rcAVI.Left) / 2, (rcParent.Bottom - rcParent.Top - rcAVI.Bottom + rcAVI.Top) / 2, rcAVI.Right - rcAVI.Left, rcAVI.Bottom - rcAVI.Top, True)
End Sub
