Attribute VB_Name = "mEditResource"

'*************Function RenameResource***************
'Purpose: Rename existing resource
'***************************************************
Public Function RenameResource(ByVal ResType As String, ByVal ResName As String, ByVal NewName As String) As Boolean
   Dim abData() As Byte
   Dim wLang As Integer
   Dim lngType As Long
   Dim lngName As Long
   Dim hRsrc As Long
   Dim hUpdateRes As Long
   Dim ret As Boolean
   
   
   abData = GetDataArray(ResType, ResName)
   If UBound(abData) < 1 Then Exit Function
   
   If Left(ResType, 1) = "#" Then ResType = Mid(ResType, 2)
   If Left(ResName, 1) = "#" Then ResName = Mid(ResName, 2)
   If Left(NewName, 1) = "#" Then NewName = Mid(NewName, 2)
   
   wLang = GetResourceLanguage(ResType, ResName)
   If wLang = 0 Then wLang = MakeLangID(LANG_NEUTRAL, SUBLANG_NEUTRAL)
   
   If IsNumeric(ResName) Then lngName = ResName Else lngName = StrPtr(ResName)
   If IsNumeric(ResType) Then lngType = ResType Else lngType = StrPtr(ResType)
   
   ClearResource
   hUpdateRes = BeginUpdateResource(StrPtr(sModuleName), 0)
   If hUpdateRes = 0 Then GoTo ExitRename
'Delete existing
   ret = UpdateResource(hUpdateRes, lngType, lngName, wLang, 0, 0)
   If ret = 0 Then GoTo ExitRename
   Call EndUpdateResource(hUpdateRes, False)
   hUpdateRes = BeginUpdateResource(StrPtr(sModuleName), 0)
   Call EndUpdateResource(hUpdateRes, False)
   
'Write new
   hUpdateRes = BeginUpdateResource(StrPtr(sModuleName), 0)
   If IsNumeric(NewName) Then lngName = NewName Else lngName = StrPtr(NewName)
   ret = UpdateResource(hUpdateRes, lngType, lngName, wLang, VarPtr(abData(0)), UBound(abData) + 1)
   If ret = 0 Then GoTo ExitRename
'If lngType = RT_ICON Or lngType = RT_CURSOR Then
'   Dim abParent() As Byte
'   abParent = GetDataArray(lngType + 11, "#1")
'End If

   Call EndUpdateResource(hUpdateRes, False)
   InitResource sModuleName
   RenameResource = True
   Exit Function
ExitRename:
   If hUpdateRes Then Call EndUpdateResource(hUpdateRes, True)
   Call FillResTypes(Form1.TreeView1, sModuleName, Form1.TreeView1.Nodes(1))
End Function

'*************Function CopyResource***************
'Purpose: Copy existing resource to string
'***************************************************
Public Function CopyResource(ByVal ResType As String, ByVal ResName As String) As String
   Dim abData() As Byte
   Dim abRes() As Byte
   Dim wID() As Integer
   
   Dim sData As String
   Dim sTemp As String
   
   Dim nCount As Integer
   Dim i As Long
   Dim dwChild As Long
   Dim lngType As Long
   
   If IsNumeric(ResType) Then lngType = CLng(ResType)
   abData = GetDataArray(ResType, ResName)
   sData = ResType & String(32 - Len(ResType), " ")
   sData = sData & ResName & String(32 - Len(ResName), " ")
   sTemp = StrConv(abData, vbUnicode)
   sData = sData & Right("000000000" & CStr(Len(sTemp)), 9)
   sData = sData & sTemp
   
   If lngType = RT_GROUP_CURSOR Or lngType = RT_GROUP_ICON Then
      CopyMemory nCount, abData(4), 2
      If nCount = 0 Then Exit Function
      ReDim wID(1 To nCount)
      dwChild = lngType - 11
      sData = sData & Right("00000" & CStr(nCount), 5)
      For i = 1 To nCount
          CopyMemory wID(i), abData(4 + 14 * i), 2
          sData = sData & Right("00000" & CStr(wID(i)), 5)
          abRes = GetDataArray(CStr(dwChild), "#" & CStr(wID(i)))
          sTemp = StrConv(abRes, vbUnicode)
          sData = sData & Right("000000000" & CStr(Len(sTemp)), 9)
          sData = sData & sTemp
      Next i
   End If
   CopyResource = sData
End Function

'*************Function PasteResource***************
'Purpose: Paste saved resource
'***************************************************
Public Function PasteResource(ByVal sData As String, Optional ResName As String, Optional ResType As String) As Boolean
   If Len(sData) < 65 Then Exit Function
   
   Dim sType As String, sName As String
   Dim abData() As Byte
   Dim abRes() As Byte
   Dim iLength As Long
   Dim nCount As Integer
   Dim i As Long
   Dim dwChild As Long
   Dim lngType As Long
   Dim id As Integer
   Dim dwOffset As Long
      
   sType = Trim(Left(sData, 32))
   If (ResName <> "") And (sType = ResType) Then
      sName = ResName
   Else
      sName = Trim(Mid(sData, 33, 32))
   End If
   If IsResourceExists(sType, sName) Then
      DeleteResource sType, sName, , , False
   End If
   iLength = CLng(Mid(sData, 65, 9))
   abData = StrConv(Mid(sData, 74, iLength), vbFromUnicode)
   WriteResource sType, sName, abData, , , False
   If IsNumeric(sType) Then lngType = CLng(sType)
   If lngType = RT_GROUP_CURSOR Or lngType = RT_GROUP_ICON Then
      nCount = CInt(Mid(sData, 74 + iLength, 5))
      dwChild = lngType - 11
      dwOffset = 79 + iLength
      For i = 1 To nCount
          id = CInt(Mid(sData, dwOffset, 5))
          id = FindNextFreeID(dwChild, id)
          iLength = CLng(Mid(sData, dwOffset + 5, 9))
          abData = StrConv(Mid(sData, dwOffset + 14, iLength), vbFromUnicode)
          WriteResource dwChild, "#" & CStr(id), abData, , , False
          dwOffset = dwOffset + iLength + 14
      Next i
   End If
   ClearResource
   Call FillResTypes(Form1.TreeView1, sModuleName, Form1.TreeView1.Nodes(1))
End Function

'*************Function DeleteResource***************
'Purpose: Delete existing resource
'***************************************************
Public Function DeleteResource(ByVal ResType As String, ByVal ResName As String, _
        Optional LANG_XXX As LANG_ID = LANG_NONE, _
        Optional SUBLANG_XXX As SUBLANG_ID = SUBLANG_NONE, _
        Optional bRefreshView As Boolean = True, _
        Optional bDeleteChilds As Boolean = True) As Boolean
   
   If sModuleName = "" Or hModule = 0 Then Exit Function
   
   Dim wLang As Integer
   Dim lngType As Long
   Dim lngName As Long
   Dim hRsrc As Long
   Dim hUpdateRes As Long
   Dim ret As Boolean
   Dim nCount As Integer
   Dim wID() As Integer
   Dim i As Long
   Dim dwChild As Long
   
   Dim abData() As Byte
   
   If Left(ResType, 1) = "#" Then ResType = Mid(ResType, 2)
   If Left(ResName, 1) = "#" Then ResName = Mid(ResName, 2)
   
   If (LANG_XXX = LANG_NONE) Or (SUBLANG_XXX = SUBLANG_NONE) Then
      wLang = GetResourceLanguage(ResType, ResName)
      If wLang = 0 Then wLang = MakeLangID(LANG_NEUTRAL, SUBLANG_NEUTRAL)
   Else
      wLang = MakeLangID(LANG_XXX, SUBLANG_XXX)
   End If
   
   If IsNumeric(ResName) Then
      lngName = ResName
      ResName = "#" & ResName
   Else
      lngName = StrPtr(ResName)
   End If
   
   If IsNumeric(ResType) Then lngType = ResType Else lngType = StrPtr(ResType)
   
   If IsNumeric(ResType) Then hRsrc = FindResourceExByNum(hModule, CLng(ResType), ResName, wLang)
   If hRsrc = 0 Then hRsrc = FindResourceEx(hModule, ResType, ResName, wLang)
   If hRsrc = 0 Then Exit Function
   If lngType = RT_GROUP_CURSOR Or lngType = RT_GROUP_ICON Then
      abData = GetDataArray(ResType, ResName)
      CopyMemory nCount, abData(4), 2
      If nCount = 0 Then Exit Function
      ReDim wID(1 To nCount)
      dwChild = lngType - 11
      For i = 1 To nCount
          CopyMemory wID(i), abData(4 + 14 * i), 2
      Next i
   End If
   
   ClearResource
   
   hUpdateRes = BeginUpdateResource(StrPtr(sModuleName), 0)
   If hUpdateRes = 0 Then GoTo ExitDelete
   If dwChild > 0 Then
      For i = 1 To nCount
          ret = UpdateResource(hUpdateRes, dwChild, wID(i), wLang, ByVal 0&, 0)
      Next i
   End If

   ret = UpdateResource(hUpdateRes, lngType, lngName, wLang, 0, 0)
   Call EndUpdateResource(hUpdateRes, False)
   hUpdateRes = BeginUpdateResource(StrPtr(sModuleName), 0)
   Call EndUpdateResource(hUpdateRes, False)
   
ExitDelete:
   If bRefreshView Then
      Call FillResTypes(Form1.TreeView1, sModuleName, Form1.TreeView1.Nodes(1))
   Else
      InitResource sModuleName
   End If
   DeleteResource = ret
End Function

'*************Function WriteResource***************
'Purpose: Write resource
'Function add new resource or overwrite existing
'***************************************************

Public Function WriteResource(ByVal ResType As String, _
        ByVal ResName As String, abNewData() As Byte, _
        Optional LANG_XXX As LANG_ID = LANG_NONE, _
        Optional SUBLANG_XXX As SUBLANG_ID = SUBLANG_NONE, _
        Optional bRefreshView As Boolean = True) As Boolean
   
   If sModuleName = "" Or hModule = 0 Then Exit Function
   
   Dim lngType As Long
   Dim lngName As Long
   Dim hRsrc As Long
   Dim hUpdateRes As Long
   Dim wLang As Integer
   Dim ret As Boolean
   
   If Left(ResType, 1) = "#" Then ResType = Mid(ResType, 2)
   If Left(ResName, 1) = "#" Then ResName = Mid(ResName, 2)
   If (LANG_XXX = LANG_NONE) Or (SUBLANG_XXX = SUBLANG_NONE) Then
      wLang = GetResourceLanguage(ResType, ResName)
      If wLang = 0 Then wLang = MakeLangID(LANG_NEUTRAL, SUBLANG_NEUTRAL)
   Else
      wLang = MakeLangID(LANG_XXX, SUBLANG_XXX)
   End If
   
   If IsNumeric(ResName) Then
      lngName = ResName
      ResName = "#" & ResName
   Else
      lngName = StrPtr(ResName)
   End If
   
   If IsNumeric(ResType) Then lngType = ResType Else lngType = StrPtr(ResType)
   
   ClearResource
   
   hUpdateRes = BeginUpdateResource(StrPtr(sModuleName), 0)
   If hUpdateRes = 0 Then GoTo ExitWrite
   ret = UpdateResource(hUpdateRes, lngType, lngName, wLang, VarPtr(abNewData(0)), UBound(abNewData) + 1)
   Call EndUpdateResource(hUpdateRes, False)
   
ExitWrite:
   If bRefreshView Then
      Call FillResTypes(Form1.TreeView1, sModuleName, Form1.TreeView1.Nodes(1))
   Else
      InitResource sModuleName
   End If
   WriteResource = ret
End Function

'Helper function to write bitmap resource from *.bmp file
Public Function ResWriteBitmapFromFile(ByVal sFile As String, ByVal ResName As String) As Boolean
   Dim fSize As Long
   Dim abRes() As Byte
   Dim nFile As Integer
   Dim sExt As String
   If ResName = "" Then ResName = InputBox("Enter resource name for the bitmap", "Add bitmap", "IDB_CUSTOM")
   If ResName = "" Then
      MsgBox "Invalid name!", vbCritical
      Exit Function
   End If
   sExt = GetExtension(sFile)
   If sExt <> "bmp" Then
      MsgBox "Invalid file extension!", vbCritical
      Exit Function
   End If
   nFile = FreeFile
   Open sFile For Binary As #nFile
      fSize = LOF(nFile)
      If fSize < 15 Then
         Close #nFile
         Exit Function
      End If
      ReDim abRes(fSize - 14)
      Get #nFile, 15, abRes
   Close #nFile
   ResWriteBitmapFromFile = WriteResource("2", ResName, abRes)
End Function

'Helper function to write bitmap resource from a Picture object
Public Function ResWriteBitmapFromStdPicture(ByVal sPic As StdPicture, ByVal ResName As String) As Boolean
   SavePicture sPic, TEMP_FILE_NAME
   ResWriteBitmapFromhBitmap = ResWriteBitmapFromFile(TEMP_FILE_NAME, ResName)
   Kill TEMP_FILE_NAME
End Function

'Helper function to write icon/cursor resource(s) from *.ico/*.cur file
Public Function ResWriteIconFromFile(ByVal sFile As String, ByVal ResType As Long, ByVal ResName As String, Optional idIcon As Integer = -1) As Boolean
   If ResType <> 1 And ResType <> 3 And ResType <> 12 And ResType <> 14 Then Exit Function
   Dim sExt As String
   sExt = GetExtension(sFile)
   If sExt <> "ico" And sExt <> "cur" Then Exit Function
   
   Dim abFile() As Byte
   Dim abRes() As Byte
   Dim abDirRes() As Byte
   Dim nFile As Integer
   Dim fSize As Long
   Dim nCount As Integer
   Dim i As Long
   Dim ResId As Long
   
   nFile = FreeFile
   Open sFile For Binary As #nFile
      fSize = LOF(nFile)
      If fSize < 20 Then
         Close #nFile
         Exit Function
      End If
      ReDim abFile(fSize)
      Get #nFile, , abFile
   Close #nFile
   CopyMemory nCount, abFile(4), 2
   If nCount = 0 Then Exit Function
   If idIcon > nCount Then Exit Function
   DeleteResource CStr(ResType), ResName, , , False
   ResId = 1
   
   Select Case ResType
       Case 1 'RT_CURSOR
            If idIcon = -1 Then idIcon = 1
            MakeSingleCursor idIcon, abFile, abRes
            WriteResource CStr(ResType), ResName, abRes
       Case 3  'RT_ICON
            If idIcon = -1 Then idIcon = 1
            MakeSingleIcon idIcon, abFile, abRes
            WriteResource CStr(ResType), ResName, abRes
       Case 12 'RT_GROUP_CURSOR
            If idIcon = -1 Then
               ReDim abDirRes(5 + nCount * 14)
               CopyMemory abDirRes(0), abFile(0), 6
               For i = 1 To nCount
                   MakeSingleCursor ResId, abFile, abRes
                   ResId = FindNextFreeID(RT_CURSOR, ResId)
                   WriteResource ResType - 11, ResId, abRes, , , False
                   
                   abDirRes(i * 14 - 8) = abFile(16 * i - 10)              'width
                   abDirRes(i * 14 - 6) = abFile(16 * i - 9)               'height
                   abDirRes(i * 14 - 2) = 2                                'ClrCount
                   CopyMemory abDirRes(i * 14), abFile(16 * i - 2), 4      'res size
                   CopyMemory abDirRes(i * 14 + 4), ResId, 2
               Next i
               WriteResource CStr(ResType), ResName, abDirRes
            Else
               MakeSingleCursor idIcon, abFile, abRes
               ResId = FindNextFreeID(RT_CURSOR, ResId)
               WriteResource ResType - 11, ResId, abRes, , , False
               ReDim abRes(19)
               abRes(2) = 2: abRes(4) = 1
               abRes(6) = abFile(16 * idIcon - 10)                   'Width
               abRes(8) = abFile(16 * idIcon - 10)                   'Height
               abRes(12) = 2                                         'ClrCount
               CopyMemory abRes(14), abFile(16 * idIcon - 2), 4      'res size
               CopyMemory abRes(18), ResId, 2
               WriteResource CStr(ResType), ResName, abRes
            End If
       Case 14 'RT_GROUP_ICON
            If idIcon = -1 Then
               ReDim abDirRes(5 + nCount * 14)
               CopyMemory abDirRes(0), abFile(0), 6
               For i = 1 To nCount
                   MakeSingleIcon i, abFile, abRes
                   ResId = FindNextFreeID(RT_ICON, ResId)
                   WriteResource ResType - 11, ResId, abRes, , , False
                   
                   CopyMemory abDirRes(i * 14 - 8), abFile(16 * i - 10), 14
                   CopyMemory abDirRes(i * 14 + 4), ResId, 2
               Next i
               WriteResource CStr(ResType), ResName, abDirRes
            Else
               MakeSingleIcon idIcon, abFile, abRes
               ResId = FindNextFreeID(RT_ICON, ResId)
               WriteResource ResType - 11, ResId, abRes, , , False
               ReDim abRes(19)
               abRes(2) = 1: abRes(4) = 1
               CopyMemory abRes(6), abFile(16 * idIcon - 10), 14
               CopyMemory abRes(18), ResId, 2
               WriteResource CStr(ResType), ResName, abDirRes
            End If
       Case Else: Exit Function
   End Select
End Function

Private Sub MakeSingleIcon(ByVal id As Long, abFile() As Byte, abRes() As Byte)
   Dim nBytes As Long
   Dim dwOffset As Long
   CopyMemory nBytes, abFile(16 * id - 2), 4
   CopyMemory dwOffset, abFile(16 * id + 2), 4
   ReDim abRes(nBytes - 1)
   CopyMemory abRes(0), abFile(dwOffset), nBytes
End Sub

Private Sub MakeSingleCursor(ByVal id As Long, abFile() As Byte, abRes() As Byte)
   Dim nBytes As Long
   Dim dwOffset As Long
   Dim xHotSpot As Integer
   Dim yHotSpot As Integer
   
   CopyMemory xHotSpot, abFile(16 * id - 6), 2
   CopyMemory yHotSpot, abFile(16 * id - 4), 2
   CopyMemory nBytes, abFile(16 * id - 2), 4
   CopyMemory dwOffset, abFile(16 * id + 2), 4
   ReDim abRes(nBytes + 3)
   CopyMemory abRes(0), xHotSpot, 2
   CopyMemory abRes(2), yHotSpot, 2
   CopyMemory abRes(4), abFile(dwOffset), nBytes
End Sub

Private Function GetExtension(ByVal sFile As String) As String
   Dim nPos As Integer
   nPos = InStrRev(sFile, ".")
   If nPos Then GetExtension = LCase(Mid(sFile, nPos + 1))
End Function

Private Function FindNextFreeID(ByVal ResType As Long, ByVal id As Long) As Long
   Dim hRsrc As Long
   Do
      If Not IsResourceExists(CStr(ResType), "#" & CStr(id)) Then Exit Do
      id = id + 1
   Loop
   FindNextFreeID = id
End Function
