Attribute VB_Name = "mMain"
Option Explicit

Public Enum LANG_ID
    LANG_NONE = -1
    LANG_NEUTRAL = &H0
    LANG_BULGARIAN = &H2
    LANG_CHINESE = &H4
    LANG_CROATIAN = &H1A
    LANG_CZECH = &H5
    LANG_DANISH = &H6
    LANG_DUTCH = &H13
    LANG_ENGLISH = &H9
    LANG_FINNISH = &HB
    LANG_FRENCH = &HC
    LANG_GERMAN = &H7
    LANG_GREEK = &H8
    LANG_HUNGARIAN = &HE
    LANG_ICELANDIC = &HF
    LANG_ITALIAN = &H10
    LANG_JAPANESE = &H11
    LANG_KOREAN = &H12
    LANG_NORWEGIAN = &H14
    LANG_POLISH = &H15
    LANG_PORTUGUESE = &H16
    LANG_ROMANIAN = &H18
    LANG_RUSSIAN = &H19
    LANG_SLOVAK = &H1B
    LANG_SLOVENIAN = &H24
    LANG_SPANISH = &HA
    LANG_SWEDISH = &H1D
    LANG_TURKISH = &H1F
End Enum

Public Enum SUBLANG_ID
    SUBLANG_NONE = -1
    SUBLANG_NEUTRAL = &H0                       '  language neutral
    SUBLANG_DEFAULT = &H1                       '  user default
    SUBLANG_SYS_DEFAULT = &H2                   '  system default
    SUBLANG_CHINESE_TRADITIONAL = &H1           '  Chinese (Taiwan)
    SUBLANG_CHINESE_SIMPLIFIED = &H2            '  Chinese (PR China)
    SUBLANG_CHINESE_HONGKONG = &H3              '  Chinese (Hong Kong)
    SUBLANG_CHINESE_SINGAPORE = &H4             '  Chinese (Singapore)
    SUBLANG_DUTCH = &H1                         '  Dutch
    SUBLANG_DUTCH_BELGIAN = &H2                 '  Dutch (Belgian)
    SUBLANG_ENGLISH_US = &H1                    '  English (USA)
    SUBLANG_ENGLISH_UK = &H2                    '  English (UK)
    SUBLANG_ENGLISH_AUS = &H3                   '  English (Australian)
    SUBLANG_ENGLISH_CAN = &H4                   '  English (Canadian)
    SUBLANG_ENGLISH_NZ = &H5                    '  English (New Zealand)
    SUBLANG_ENGLISH_EIRE = &H6                  '  English (Irish)
    SUBLANG_FRENCH = &H1                        '  French
    SUBLANG_FRENCH_BELGIAN = &H2                '  French (Belgian)
    SUBLANG_FRENCH_CANADIAN = &H3               '  French (Canadian)
    SUBLANG_FRENCH_SWISS = &H4                  '  French (Swiss)
    SUBLANG_GERMAN = &H1                        '  German
    SUBLANG_GERMAN_SWISS = &H2                  '  German (Swiss)
    SUBLANG_GERMAN_AUSTRIAN = &H3               '  German (Austrian)
    SUBLANG_ITALIAN = &H1                       '  Italian
    SUBLANG_ITALIAN_SWISS = &H2                 '  Italian (Swiss)
    SUBLANG_NORWEGIAN_BOKMAL = &H1              '  Norwegian (Bokma
    SUBLANG_NORWEGIAN_NYNORSK = &H2             '  Norwegian (Nynorsk)
    SUBLANG_PORTUGUESE = &H2                    '  Portuguese
    SUBLANG_PORTUGUESE_BRAZILIAN = &H1          '  Portuguese (Brazilian)
    SUBLANG_SPANISH = &H1                       '  Spanish (Castilian)
    SUBLANG_SPANISH_MEXICAN = &H2               '  Spanish (Mexican)
    SUBLANG_SPANISH_MODERN = &H3                '  Spanish (Modern)
End Enum

Public Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Function LoadLibraryEx Lib "kernel32" Alias "LoadLibraryExA" (ByVal lpLibFileName As String, ByVal hFile As Long, ByVal dwFlags As Long) As Long
Private Const DONT_RESOLVE_DLL_REFERENCES = &H1
Public Const LOAD_LIBRARY_AS_DATAFILE = 2

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function CopyStringA Lib "kernel32" Alias "lstrcpyA" (ByVal NewString As String, ByVal OldString As Long) As Long
Public Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long
Public Declare Function lstrlenA Lib "kernel32" (ByVal lpString As Long) As Long

Public hModule As Long
Public picHeight As Long, picWidth As Long
Public sModuleName As String

Public Function InitResource(ByVal sLibName As String) As Boolean
  On Error Resume Next
  If hModule Then ClearResource
  hModule = LoadLibraryEx(sLibName, 0, 1)
'  hModule = LoadLibrary(sLibName)
  InitResource = (hModule <> 0)
  If hModule Then
     sModuleName = sLibName
  Else
     sModuleName = ""
  End If
End Function

Public Sub ClearResource()
   If Dir(TEMP_FILE_NAME) <> "" Then
      Call mciSendString("close video", 0&, 0, 0)
      Kill TEMP_FILE_NAME
   End If
   If hDialog Then Call DestroyWindow(hDialog)
   If hModule Then FreeLibrary (hModule)
   hModule = 0
End Sub

Public Function ResTypeName(ByVal ResType As ResTypes) As String
   Select Case ResType
      Case RT_ACCELERATOR
         ResTypeName = "Accelerator table"
      Case RT_ANICURSOR
         ResTypeName = "Animated cursor"
      Case RT_ANIICON
         ResTypeName = "Animated icon"
      Case RT_BITMAP
         ResTypeName = "Bitmap resource"
      Case RT_CURSOR
         ResTypeName = "Hardware-dependent cursor resource"
      Case RT_DIALOG
         ResTypeName = "Dialog box"
      Case RT_DLGINCLUDE
         ResTypeName = "Header file that contains menu and dialog box #define statements"
      Case RT_FONT
         ResTypeName = "Font resource"
      Case RT_FONTDIR
         ResTypeName = "Font directory resource"
      Case RT_GROUP_CURSOR
         ResTypeName = "Hardware-independent cursor resource"
      Case RT_GROUP_ICON
         ResTypeName = "Hardware-independent icon resource"
      Case RT_HTML
         ResTypeName = "HTML document"
      Case RT_ICON
         ResTypeName = "Hardware-dependent icon resource"
      Case RT_MANIFEST
         ResTypeName = "XP manifest"
      Case RT_MENU
         ResTypeName = "Menu resource"
      Case RT_MESSAGETABLE
         ResTypeName = "Message-table entry"
      Case RT_PLUGPLAY
         ResTypeName = "Plug and play resource"
      Case RT_RCDATA
         ResTypeName = "Application-defined resource (raw data)"
      Case RT_STRING
         ResTypeName = "String-table entry"
      Case RT_VERSION
         ResTypeName = "Version resource"
      Case RT_VXD
         ResTypeName = "VXD"
      Case Else
         ResTypeName = "User-defined custom resource"
   End Select
End Function

Public Function StrFromPtrA(ByVal lpszA As Long, Optional nSize As Long = 0) As String
   Dim s As String, bTrim As Boolean
   If nSize = 0 Then
      nSize = lstrlenA(lpszA)
      bTrim = True
   End If
   s = String(nSize, Chr$(0))
   CopyStringA s, ByVal lpszA
   If bTrim Then s = TrimNULL(s)
   StrFromPtrA = s
End Function

Public Function StrFromPtrW(ByVal lpszW As Long, Optional nSize As Long = 0) As String
   Dim s As String, bTrim As Boolean
   If nSize = 0 Then
      nSize = lstrlenW(lpszW)
      bTrim = True
   End If
   s = String(nSize, Chr$(0))
   CopyMemory ByVal StrPtr(s), ByVal lpszW, nSize
   If bTrim Then s = TrimNULL(s)
   StrFromPtrW = s
End Function

Public Function TrimNULL(ByVal str As String) As String
    If InStr(str, Chr$(0)) > 0& Then
        TrimNULL = Left$(str, InStr(str, Chr$(0)) - 1&)
    Else
        TrimNULL = str
    End If
End Function

Public Function MakeLangID(ByVal usPrimaryLanguage As LANG_ID, ByVal usSubLanguage As SUBLANG_ID) As Long
    MakeLangID = usSubLanguage * 2 ^ 10 + usPrimaryLanguage
End Function

Public Function ReplaceStr(ByVal str As String, ByVal sReplace As String, Optional ByVal sReplaceWith As String, Optional fCompare As VbCompareMethod) As String
    Dim iLenOut As Integer, iLenIn As Integer
    Dim i As Long
    iLenOut = Len(sReplace)
    iLenIn = Len(sReplaceWith)
    If Len(str) > 0& Then
        If iLenOut > 0& Then
            Dim sOut As String
            i = InStr(1&, str, sReplace, fCompare)
            Do Until i = 0&
                If iLenIn > 0& Then
                    str = Left$(str, i - 1&) & sReplaceWith & Mid$(str, i + iLenOut)
                Else
                    str = Left$(str, i - 1&) & Mid$(str, i + iLenOut)
                End If
                i = InStr(i + iLenIn, str, sReplace, fCompare)
            Loop
        End If
    End If
    ReplaceStr = str
End Function

Public Function MAKEWORD(ByVal bLo As Byte, ByVal bHi As Byte) As Integer
    If bHi And &H80 Then
        MAKEWORD = (((bHi And &H7F) * 256) + bLo) Or &H8000
    Else
        MAKEWORD = (bHi * 256) + bLo
    End If
End Function

Public Function MakeDWord(ByVal wLo As Integer, ByVal wHi As Integer) As Long
    MakeDWord = (wHi * 65536) + (wLo And &HFFFF&)
End Function

Public Function IsWindowsNT() As Boolean
   IsWindowsNT = Len(Environ$("OS"))
End Function

