Attribute VB_Name = "mPE"
'*********************************************************************************
'*Module for retriving main resource info from PE (portable executable) file data*
'*********************Simplified to get resources info only***********************
'*********************************************************************************
Option Explicit
Const IMAGE_SIZEOF_SHORT_NAME = 8

Private Type IMAGE_SECTION_HEADER
   SecName As String * IMAGE_SIZEOF_SHORT_NAME
   PhysicalAddress As Long
   VirtualAddress  As Long
   SizeOfRawData As Long
   PointerToRawData As Long
   PointerToRelocations As Long
   PointerToLinenumbers As Long
   NumberOfRelocations As Integer
   NumberOfLinenumbers As Integer
   Characteristics  As Long
End Type
Const IMAGE_SCN_MEM_READ = &H40000000                   ' Section is readable.
Const IMAGE_SCN_MEM_WRITE = &H80000000                  ' Section is writeable.

Private Type LIST_ENTRY
   Flk As Long
   Blk As Long
End Type

Private Type LOADED_IMAGE
    ModuleName As Long
    hFile As Long
    MappedAddress As Long    ' UCHAR *
    FileHeader As Long       ' IMAGE_NT_HEADERS *
    LastRvaSection As Long   ' IMAGE_SECTION_HEADER *
    NumberOfSections As Long
    Sections As Long         ' IMAGE_SECTION_HEADER *
    Characteristics As Long
    fSystemImage As Byte
    fDOSImage As Byte
    Lks As LIST_ENTRY
    SizeOfImage As Long
End Type

Private Declare Function MapAndLoad Lib "imagehlp" ( _
    ByVal ImageName As String, ByVal DllPath As String, _
    LoadedImage As LOADED_IMAGE, ByVal DotDll As Long, _
    ByVal ReadOnly As Long) As Long

Private Declare Function UnMapAndLoad Lib "imagehlp" (LoadedImage As LOADED_IMAGE) As Long

Public sPEResInfo As String

Public Function GetPEResourceInfo(ByVal sFile As String) As Boolean
   Dim m_LI As LOADED_IMAGE
   Dim Sect As IMAGE_SECTION_HEADER
   Dim i As Long, lpSect As Long
   Dim bRes As Boolean
   Dim sNot As String
   
   sPEResInfo = ""
   If MapAndLoad(sFile & vbNullString, vbNullString, m_LI, True, True) Then
      For i = 0 To m_LI.NumberOfSections - 1
          lpSect = m_LI.Sections + (i * Len(Sect))
          CopyMemory Sect, ByVal lpSect, Len(Sect)
          If TrimNULL(Sect.SecName) = ".rsrc" Then
             sPEResInfo = "Total resource size: " & Format$(Sect.SizeOfRawData, "#,##0") & " bytes."
             sNot = IIf(((Sect.Characteristics And IMAGE_SCN_MEM_READ) = IMAGE_SCN_MEM_READ), "", "not ")
             sPEResInfo = sPEResInfo & vbCrLf & "Resources can " & sNot & "be read."
             sNot = IIf(((Sect.Characteristics And IMAGE_SCN_MEM_WRITE) = IMAGE_SCN_MEM_WRITE), "", "not ")
             sPEResInfo = sPEResInfo & vbCrLf & "Resources can " & sNot & "be written."
             Exit For
          End If
      Next
      UnMapAndLoad m_LI
   End If
   GetPEResourceInfo = (sPEResInfo <> "")
End Function
