Attribute VB_Name = "mResDefs"
'API resource functions defenitions

Public Enum ResTypes 'Resource types
   RT_CURSOR = 1&
   RT_BITMAP = 2&
   RT_ICON = 3&
   RT_MENU = 4&
   RT_DIALOG = 5&
   RT_STRING = 6&
   RT_FONTDIR = 7&
   RT_FONT = 8&
   RT_ACCELERATOR = 9&
   RT_RCDATA = 10&
   RT_MESSAGETABLE = 11&
   RT_GROUP_CURSOR = 12&
   RT_GROUP_ICON = 14&
   RT_VERSION = 16&
   RT_DLGINCLUDE = 17&
   RT_PLUGPLAY = 19&
   RT_VXD = 20&
   RT_ANICURSOR = 21&
   RT_ANIICON = 22&
   RT_HTML = 23&
   RT_MANIFEST = 24&
End Enum
'===============Resource block entries================
'*************Accelerator table***************
Public Type ACCEL_TABLE_ENTRY
   fFlags As Integer
   wASCII As Integer
   wID As Integer
   wPadding As Integer
End Type
'*****************Menu************************
Public Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

'Message table structure
Public Type MESSAGE_RESOURCE_BLOCK
   LowId As Long
   HighId As Long
   OffsetToEntries As Long
End Type

Public Type MESSAGE_RESOURCE_ENTRY
  uLength As Integer
  iFlags As Integer
  sText As String
End Type

Public Type MESSAGE_RESOURCE_DATA
   NumberOfBlocks As Long
   mrb() As MESSAGE_RESOURCE_BLOCK
   mre() As MESSAGE_RESOURCE_ENTRY
End Type

'Resource functions
Public Declare Function FindResource Lib "kernel32" Alias "FindResourceA" (ByVal hInstance As Long, ByVal lpName As String, ByVal lpType As String) As Long
Public Declare Function FindResourceByNum Lib "kernel32" Alias "FindResourceA" (ByVal hInstance As Long, ByVal lpName As String, ByVal lpType As Long) As Long
Public Declare Function FindResourceEx Lib "kernel32" Alias "FindResourceExA" (ByVal hModule As Long, ByVal lpType As String, ByVal lpName As String, ByVal wLanguage As Long) As Long
Public Declare Function FindResourceExByNum Lib "kernel32" Alias "FindResourceExA" (ByVal hModule As Long, ByVal lpType As Long, ByVal lpName As String, ByVal wLanguage As Long) As Long
Public Declare Function LoadResource Lib "kernel32" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long
Public Declare Function LockResource Lib "kernel32" (ByVal hResData As Long) As Long
Public Declare Function SizeofResource Lib "kernel32" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long
Public Declare Function FreeResource Lib "kernel32" (ByVal hResData As Long) As Long

'Resource updating (NT/2000/XP only) - Unicode versions
Public Declare Function BeginUpdateResourceNT Lib "kernel32" Alias "BeginUpdateResourceW" (ByVal pFileName As Long, ByVal bDeleteExistingResources As Long) As Long
Public Declare Function UpdateResourceNT Lib "kernel32" Alias "UpdateResourceW" (ByVal hUpdate As Long, ByVal lpType As Long, ByVal lpName As Long, ByVal wLanguage As Integer, lpData As Any, ByVal cbData As Long) As Long
Public Declare Function EndUpdateResourceNT Lib "kernel32" Alias "EndUpdateResourceW" (ByVal hUpdate As Long, ByVal fDiscard As Long) As Long

'Resource enumeration
Public Declare Function EnumResourceTypes Lib "kernel32" Alias "EnumResourceTypesA" (ByVal hModule As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function EnumResourceNames Lib "kernel32" Alias "EnumResourceNamesA" (ByVal hModule As Long, ByVal lpType As String, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function EnumResourceNamesById Lib "kernel32" Alias "EnumResourceNamesA" (ByVal hModule As Long, ByVal lpType As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function EnumResourceLanguages Lib "kernel32" Alias "EnumResourceLanguagesA" (ByVal hModule As Long, ByVal lpType As Long, ByVal lpName As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long

Public Function BeginUpdateResource(ByVal pFileName As Long, ByVal bDeleteExistingResources As Long) As Long
   If IsWindowsNT Then
      BeginUpdateResource = BeginUpdateResourceNT(pFileName, bDeleteExistingResources)
   Else
   End If
End Function

Public Function UpdateResource(ByVal hUpdate As Long, ByVal lpType As Long, ByVal lpName As Long, ByVal wLanguage As Integer, ByVal lpData As Long, ByVal cbData As Long) As Long
   If IsWindowsNT Then
      UpdateResource = UpdateResourceNT(hUpdate, lpType, lpName, wLanguage, ByVal lpData, cbData)
   Else
   End If
End Function

Public Function EndUpdateResource(ByVal hUpdate As Long, ByVal fDiscard As Long) As Long
   If IsWindowsNT Then
      EndUpdateResource = EndUpdateResourceNT(hUpdate, fDiscard)
   Else
   End If
End Function

